// const width = document.body.clientWidth;
// const height = document.body.clientHeight;
const width = '500';
const height = '500';
const transitionDuration = 1000; 
let level = 0; 
//Zoom
  let zzoom = d3.zoom().scaleExtent([1, 8]).on("zoom", zoomed); 
  function zoomed() {
  g.style("stroke-width", 1.5 / d3.event.transform.k + "px");
  g.attr("transform", d3.event.transform); // updated for d3 v4
}
const svg = d3.select('svg').attr('width', width).attr('height', height);
const g = svg.append('g');
const mercator = d3.geoMercator().scale(25000).translate([width/2, height/2]).center([73,19.7]);
const pathGenerator = d3.geoPath().projection(mercator);
//Zoom
svg.call(d3.zoom().on('zoom',() =>{
	g.attr('transform',event.transform)
}))
const render= (block,project) => {
  let SevStuntingPValue = d => d.properties.svrly_stunting_percent;
  let TextValue = null;
	let ColorValue = SevStuntingPValue;
  

 	const makemap = (geojson) => {
  if(level == 0){
  	TextValue = d => d.properties.Block;
  }else if(level == 1){
  	TextValue = d => d.properties.Project;
  }
  let min = d3.min(geojson,ColorValue);
	let max = d3.max(geojson,ColorValue);
	let comp = (max - min)/3;
  var myColor = (v,low,high) =>{
    if(v<low)
      return '#B2022F'; //matte red
    else if(v >= low && v <= high)
      return 'F4BC1C'; //matte yellow
    else if(v>high)
      return '#24562B'; //matte green
  } 
//onmouseover
let tooltip = d3.select("body").append("div") 
        .attr("class", "tooltip")       
        .style("opacity", 0);

  const onMouseOver = d =>{	
    tooltip.transition().duration(200).style("opacity", .9);		
    tooltip.html("<b>"+TextValue(d)+"</b><br>"+ColorValue(d)+"%")
      .style("left", d3.event.pageX + "px")
      .style("top",  d3.event.pageY - 30 + "px");
  }
  
  	let path = g.selectAll('path').data(geojson);
    let pathEnter = path
								.enter().append('path')
  							.attr('d',pathGenerator)
    						.attr('class','boundary')
    						.style("fill", d => {
      						return myColor(ColorValue(d),min+comp,max-comp);
								}).on("mouseover", d => onMouseOver(d))
    							.on("mouseout", function(d) {   
            				tooltip.transition()    
            				.duration(500)    
            				.style("opacity", 0); 
          		});
    //text over polygon
   let textLabel = g.selectAll("text").data(geojson)
    .enter().append("text")
    .text(d =>{
   return `${TextValue(d)}(${ColorValue(d)})`;
   })
    .attr("x", function(d){
        return pathGenerator.centroid(d)[0];
    })
    .attr("y", function(d){
        return  pathGenerator.centroid(d)[1];
    })
    .attr("text-anchor","middle")
    .attr('font-size','12pt')
    .attr("font-family", "sans-serif");
    
    //update slider color
     const fillSlider = () =>{
  		leftX2 = +d3.select('line.track-fill').attr("x1")-15;
  		d3.select('line.leftcolor').attr('x2',leftX2)
     };
    //when slider move
    sliderRange .on('onchange', val => {
    fillSlider();
    d3.select('p#value-range').text(val.map(d3.format('.1%')).join('-'));
      let low = (val[0]*100).toFixed(2);
      let high = (val[1]*100).toFixed(2);
			pathEnter.transition().duration(transitionDuration).style("fill", function(d) {
      	return myColor(ColorValue(d),low,high);
				})
    })
    
    const updateviz = selectedCat =>{
      
    	switch(selectedCat){
        case '1':ColorValue = d => d.properties.stunting_percent;break;
        case '2':ColorValue = d => d.properties.svrly_stunting_percent;break;
        case '3':ColorValue = d => d.properties.svrly_wasting_percent;break;
        case '4':ColorValue = d => d.properties.wasting_percent;break;
        case '5':ColorValue = d => d.properties.svrly_underweight_percent;break;
        case '6':ColorValue = d => d.properties.underweight_percent;break;
        case '7':ColorValue = d => d.properties.low_birth_weight_percent;break;
      }
        min = d3.min(geojson,ColorValue);
        max = d3.max(geojson,ColorValue);
        comp = (max - min)/3;
     	pathEnter.transition().duration(transitionDuration).style("fill", function(d) {
      	return myColor(ColorValue(d),min+comp,max-comp);
				})
      
        textLabel.text(d =>{
   return `${TextValue(d)}(${ColorValue(d)})`;
   }).exit().remove();

      
    }
    
    //on category selection
    const dropdownChange = () =>{
  		let val = document.getElementById("category").value
  		updateviz(val);
		}
// makeviz(1);

var dropdown = d3.select("#category")
    .on("change", dropdownChange);

  //zoomToBoundingBox
  const zoomToBoundingBox = d => {
  let bounds = pathGenerator.bounds(d),
      dx = bounds[1][0] - bounds[0][0],
      dy = bounds[1][1] - bounds[0][1],
      x = (bounds[0][0] + bounds[1][0]) / 2,
      y = (bounds[0][1] + bounds[1][1]) / 2,
      scale = Math.max(1, Math.min(8, 0.9 / Math.max(dx / width, dy / height))),
      translate = [width / 2 - scale * x, height / 2 - scale * y];
    svg.transition().duration(transitionDuration).call(
  	zzoom.transform, d3.zoomIdentity.translate(translate[0],translate[1]).scale(scale)
    ); 
  }
  //selectmap
const selectedSubFeature = (geojson,location) => {
  		let selection = [];
  		geojson.forEach( sel =>{
      	if (sel.properties.Block == location){
        	selection.push(sel);
        }
      });
  		return selection;
}
  // clicked
	const clicked = d =>{
  level = 1;
	zoomToBoundingBox(d);
	let selectedBlock = d.properties.Block;
	let selectedjson =  selectedSubFeature(project.Aug,selectedBlock);
	g.selectAll("*").remove();
  tooltip.remove();
	makemap(selectedjson)
	}
  pathEnter.on('click',clicked)
}
 //initial map
 d3.select('button').on('click',function(){
  level = 0;
  g.selectAll("*").remove();
  svg.transition().duration(transitionDuration).call( zzoom.transform, d3.zoomIdentity );
  makemap(block.Aug);
})
  
  const selectData = (val,allMonthData) =>{
  	switch(val){
    	case 'aug': return allMonthData.Aug;break;
      case 'sep': return allMonthData.Sep;break;
     	case 'oct': return allMonthData.Oct;break;
    }
  }
  d3.select("#monthdropdown")
    .on("change", () =>{
  				let val = document.getElementById("monthdropdown").value
  				let month = selectData(val,block);
    			level = 0;
					g.selectAll("*").remove();
          svg.transition().duration(transitionDuration).call( zzoom.transform, d3.zoomIdentity );
      		makemap(month);
    	});
  makemap(block.Aug)
}

async function fetchGeoJSON(){
  let geoJSONBundle = {}
	let blockJSON = await d3.json('block.json');
  let projectJSON = await d3.json('project.json');
  geoJSONBundle.blockJSON = blockJSON.features;
  geoJSONBundle.projectJSON = projectJSON.features;
  return geoJSONBundle;
}

const monthWiseCSV = (data) =>{
	let month = {'Aug':[],'Sep':[],'Oct':[]}
  data.forEach(d=>{
  let temp = {};
  if(d.project_n)
    temp.project_n = d.project_n
  temp.block_n = d.block_n 
  temp.mdrtly_stntd = +d.mdrtly_stntd
  temp.svrly_stntd = +d.svrly_stntd
  temp.svr_wstg = +d.svr_wstg
  temp.mdrtly_wstd = +d.mdrtly_wstd
  temp.svrly_uw = +d.svrly_uw
  temp.mdrtly_uw = +d.mdrtly_uw
  temp.nb_lbw = +d.nb_lbw
  temp.svrly_wasting_percent = +d.svrly_wasting_percent
  temp.wasting_percent = +d.wasting_percent
  temp.svrly_stunting_percent = +d.svrly_stunting_percent
  temp.stunting_percent = +d.stunting_percent
  temp.svrly_underweight_percent = +d.svrly_underweight_percent
  temp.underweight_percent = +d.underweight_percent
  temp.low_birth_weight_percent = +d.low_birth_weight_percent
  month[d.month_n].push(temp)
  })
return month;
}
const addProperty = (data,geojson) =>{
  let x,y;
	for (let i = 0; i < data.length; i++) {
  	for (let j = 0; j < geojson.length; j++){
      if(geojson[j].properties.Project){
      	x = data[i].project_n;
    		y = geojson[j].properties.Project;
      }else{
      	x = data[i].block_n;
        y= geojson[j].properties.Block;
    }
      
      if(x == y){
				geojson[j].properties.mdrtly_stntd = data[i].mdrtly_stntd 
        geojson[j].properties.svrly_stntd = data[i].svrly_stntd	
        geojson[j].properties.svr_wstg = data[i].svr_wstg
        geojson[j].properties.mdrtly_wstd = data[i].mdrtly_wstd
        geojson[j].properties.svrly_uw = data[i].svrly_uw
        geojson[j].properties.mdrtly_uw = data[i].mdrtly_uw
        geojson[j].properties.nb_lbw = data[i].nb_lbw
        geojson[j].properties.svrly_wasting_percent = data[i].svrly_wasting_percent
        geojson[j].properties.wasting_percent = data[i].wasting_percent
        geojson[j].properties.svrly_stunting_percent = data[i].svrly_stunting_percent
        geojson[j].properties.stunting_percent = data[i].stunting_percent
        geojson[j].properties.svrly_underweight_percent = data[i].svrly_underweight_percent
        geojson[j].properties.underweight_percent = data[i].underweight_percent
        geojson[j].properties.low_birth_weight_percent = data[i].low_birth_weight_percent     
      }
      
    }
  }

}
async function mergeData(geoJSON){
  //merging block data
	let blockGeoJSON = geoJSON.blockJSON;
  let blockCSV = await d3.csv('block.csv');
  let blockMonthWiseCSV = monthWiseCSV(blockCSV);
    console.table(blockMonthWiseCSV.Aug,['block_n','svrly_stunting_percent','stunting_percent']);

  let blockGeoJSONAug = JSON.parse(JSON.stringify(blockGeoJSON));
  let blockGeoJSONSep = JSON.parse(JSON.stringify(blockGeoJSON));
  let blockGeoJSONOct = JSON.parse(JSON.stringify(blockGeoJSON));
  //call by reference so need to return
  addProperty(blockMonthWiseCSV.Aug,blockGeoJSONAug);
  addProperty(blockMonthWiseCSV.Sep,blockGeoJSONSep);
  addProperty(blockMonthWiseCSV.Oct,blockGeoJSONOct);
	const mergedBlock = {'Aug':blockGeoJSONAug,'Sep':blockGeoJSONSep,'Oct':blockGeoJSONOct}
  //merging project data
  let projectGeoJSON = geoJSON.projectJSON;
	let projectCSV = await d3.csv('project.csv');
  let projectMonthWiseCSV = monthWiseCSV(projectCSV);
  let projectGeoJSONAug = JSON.parse(JSON.stringify(projectGeoJSON));
  let projectGeoJSONSep = JSON.parse(JSON.stringify(projectGeoJSON));
  let projectGeoJSONOct = JSON.parse(JSON.stringify(projectGeoJSON));
  addProperty(projectMonthWiseCSV.Aug,projectGeoJSONAug);
  addProperty(projectMonthWiseCSV.Sep,projectGeoJSONSep);
  addProperty(projectMonthWiseCSV.Oct,projectGeoJSONOct);
  const mergedProject = {'Aug':projectGeoJSONAug,'Sep':projectGeoJSONSep,'Oct':projectGeoJSONOct}
  render(mergedBlock,mergedProject)
}
fetchGeoJSON().then(mergeData)

var sliderRange = d3
    .sliderBottom()
    .min(0)
    .max(.999)
    .width(300)
    .tickFormat(d3.format('.1%'))
    .ticks(5)
    .default([.25, .50])
    .fill('yellow')
    .handle(d3.symbol().type(d3.symbolCircle).size(550)());

var gRange = d3
    .select('div#slider-range')
    .append('svg')
    .attr('width', 500)
    .attr('height', 100)
    .append('g')
    .attr('transform', 'translate(30,30)');
  
gRange.call(sliderRange);

let leftX1 = +d3.select('line.track-inset').attr("x1");
let leftX2 = +d3.select('line.track-fill').attr("x1")-15;
d3.select('g.slider').append('line').attr('class','leftcolor')
  .attr('x1',leftX1).attr('x2',leftX2)
	.attr('stroke-width',4).attr('stroke-linecap','round');

d3.select('line.track-fill').attr('stroke','yellow')
d3.select('line.leftcolor').attr('stroke','red')
d3.select('line.track-inset').attr('stroke','green')

